#!/bin/sh -x

# /www/cgi-bin/config/config5.sh

# Remove the old script file
#rm /tmp/config6.sh >> /dev/null

# Build the new script file
#---------------------------------------------------
cat > /tmp/config6.sh << EOF

#!/bin/sh

# Clear settings for checkboxes and buttons
ENABLE=""
REGISTER=""
BUTTON=""
DHCP_ENABLE=""

# Get Field-Value pairs from QUERY_STRING enironment variable
# set by the form GET action
# Cut into individual strings: Field=Value


`echo $QUERY_STRING | cut -d \& -f 1`
`echo $QUERY_STRING | cut -d \& -f 2`
`echo $QUERY_STRING | cut -d \& -f 3`
`echo $QUERY_STRING | cut -d \& -f 4`
`echo $QUERY_STRING | cut -d \& -f 5`
`echo $QUERY_STRING | cut -d \& -f 6`
`echo $QUERY_STRING | cut -d \& -f 7`
`echo $QUERY_STRING | cut -d \& -f 8`
`echo $QUERY_STRING | cut -d \& -f 9`
`echo $QUERY_STRING | cut -d \& -f 10`
`echo $QUERY_STRING | cut -d \& -f 11`
`echo $QUERY_STRING | cut -d \& -f 12`
`echo $QUERY_STRING | cut -d \& -f 13`
`echo $QUERY_STRING | cut -d \& -f 14`
`echo $QUERY_STRING | cut -d \& -f 15`
`echo $QUERY_STRING | cut -d \& -f 16`
`echo $QUERY_STRING | cut -d \& -f 17`
`echo $QUERY_STRING | cut -d \& -f 18`
`echo $QUERY_STRING | cut -d \& -f 19`
`echo $QUERY_STRING | cut -d \& -f 20`
`echo $QUERY_STRING | cut -d \& -f 21`
`echo $QUERY_STRING | cut -d \& -f 22`
`echo $QUERY_STRING | cut -d \& -f 23`
`echo $QUERY_STRING | cut -d \& -f 24`
`echo $QUERY_STRING | cut -d \& -f 25`
`echo $QUERY_STRING | cut -d \& -f 26`
`echo $QUERY_STRING | cut -d \& -f 27`
`echo $QUERY_STRING | cut -d \& -f 28`
`echo $QUERY_STRING | cut -d \& -f 29`
`echo $QUERY_STRING | cut -d \& -f 30`
`echo $QUERY_STRING | cut -d \& -f 31`
`echo $QUERY_STRING | cut -d \& -f 32`
`echo $QUERY_STRING | cut -d \& -f 33`
`echo $QUERY_STRING | cut -d \& -f 34`
`echo $QUERY_STRING | cut -d \& -f 35`
`echo $QUERY_STRING | cut -d \& -f 36`
`echo $QUERY_STRING | cut -d \& -f 37`
`echo $QUERY_STRING | cut -d \& -f 38`
`echo $QUERY_STRING | cut -d \& -f 39`


# Refresh screen without saving 
if [ \$BUTTON = "Refresh" ]; then
	exit
fi

# Restore default config settings
if [ \$BUTTON = "Restore+Defaults" ]; then
	cd /etc/config
	tar -xzvf conf-default.tar.gz >> /dev/null
	cd
	/etc/init.d/config_secn > /dev/null  # Create new config files
	exit
fi

# Fix the handling of the 'hash' character
if [ \$DIALOUT = "%23" ]; then
	DIALOUT="#"
fi

# Fix ATH0_BSSID string colon characters - replace '%3A' with ':'
ATH0_BSSID=\$(echo \$ATH0_BSSID | sed -e s/%3A/:/g)


# Write the Field values into the SECN config settings

# Write br_lan network settings into /etc/config/network
uci set network.lan.ipaddr=\$BR_IPADDR
uci set network.lan.dns=\$BR_DNS
uci set network.lan.gateway=\$BR_GATEWAY
uci set network.lan.netmask=\$BR_NETMASK

# Write the ath0 settings into /etc/config/network
uci set network.wifi0.ipaddr=\$ATH0_IPADDR
uci set network.wifi0.netmask=\$ATH0_NETMASK

# Write the ath0 settings into /etc/config/wireless
uci set wireless.wifi0.country=\$ATH0_COUNTRY
uci set wireless.wifi0.channel=\$CHANNEL
uci set wireless.mesh.ssid=\$ATH0_SSID
uci set wireless.mesh.txpower=\$ATH0_TXPOWER
uci set wireless.mesh.bssid=\$ATH0_BSSID

# Write the Access Point wifi settings into /etc/config/secn
uci set secn.accesspoint.ssid=\$SSID
uci set secn.accesspoint.encryption=\$ENCRYPTION
uci set secn.accesspoint.passphrase=\$PASSPHRASE

# Write the Asterisk settings into /etc/config/secn
uci set secn.asterisk.host=\$HOST
uci set secn.asterisk.reghost=\$REGHOST
uci set secn.asterisk.secret=\$SECRET
uci set secn.asterisk.username=\$USER
uci set secn.asterisk.fromusername=\$USER
uci set secn.asterisk.enable=\$ENABLE
uci set secn.asterisk.register=\$REGISTER
uci set secn.asterisk.dialout=\$DIALOUT
uci set secn.asterisk.codec1=\$CODEC1
uci set secn.asterisk.codec2=\$CODEC2
uci set secn.asterisk.codec3=\$CODEC3
uci set secn.asterisk.externip=\$EXTERNIP
uci set secn.asterisk.enablenat=\$ENABLENAT

# Write the DHCP settings into /etc/config/secn
uci set secn.dhcp.enable=\$DHCP_ENABLE
uci set secn.dhcp.startip=\$STARTIP
uci set secn.dhcp.endip=\$ENDIP
uci set secn.dhcp.maxleases=\$MAXLEASES
uci set secn.dhcp.leaseterm=\$LEASETERM
uci set secn.dhcp.domain=\$DOMAIN
uci set secn.dhcp.dns=\$OPTION_DNS
uci set secn.dhcp.subnet=\$OPTION_SUBNET
uci set secn.dhcp.router=\$OPTION_ROUTER

# Commit the settings into /etc/config/ files
uci commit secn
uci commit network
uci commit wireless

# Create new config files
/etc/init.d/config_secn > /dev/null
# Make sure file writing is complete
sleep 2

if [ \$BUTTON = "Save+and+Reboot" ]; then
# Reboot the MP
reboot
fi

if [ \$BUTTON = "Save+and+Restart+Asterisk" ]; then
# Restart Asterisk
/etc/init.d/asterisk restart > /dev/null &
# Allow time to register
sleep 5
fi

EOF
#-------------------------------------------------

# Make the file executable and run it to update the config settings.
chmod +x /tmp/config6.sh
/tmp/config6.sh

# Build the configuration screen and send it back to the browser.
/www/cgi-bin/secn-adv


